<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>Select a crop to proceed with the fertilization plan.</translate>
          </q-banner>

          <q-card-section>
            <q-select
              v-model="storePlantSpecies"
              :label="$gettext('Crop')"
              :options="plantSpeciesOptions"
              option-value="id"
              option-label="name"
              filled
              @filter="filterPlantSpecies"
              use-input
              input-debounce="200"
              :loading="$apollo.queries.plantSpecies.loading"
              @update:model-value="onPlantSpeciesChange"
              class="q-mt-md"
            />

            <div
              v-if="loading"
              class="column flex-center q-mt-md"
            >
              <q-spinner-dots
                color="primary"
                size="24px"
              />
            </div>
            <q-list
              v-else-if="cropProfileOptions && cropProfileOptions.length > 1"
              class="q-mt-md"
            >
              <q-item
                v-for="cropProfileOption in cropProfileOptions"
                :key="cropProfileOption.id"
                tag="label"
                v-ripple
                dense
                class="q-px-none"
              >
                <q-item-section avatar>
                  <q-radio
                    :val="cropProfileOption.id"
                    :model-value="storeCropProfile ? storeCropProfile.id : null"
                    @update:model-value="onUpdateCropProfileId"
                  />
                </q-item-section>
                <q-item-section>
                  <q-item-label>{{ cropProfileOption.name }} </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
            <q-banner
              v-if="showCropProfileUnavailableBanner"
              class="bg-accent text-white q-mt-sm"
            >
              <translate>The crop %{storePlantSpecies.name} is not currently covered by %{algorithmName}.</translate>
            </q-banner>

            <template v-if="hasCropMainProductOptions">
              <q-select
                v-model="storeCropMainProduct"
                :options="cropMainProductOptions"
                option-value="id"
                option-label="name"
                filled
                :loading="loading"
                :label="$gettext('Crop main product')"
                @update:model-value="onCropMainProductChange"
                class="q-mt-md"
              />

              <q-input
                v-if="isCropMainProductSelected"
                v-model.number="storeCropMainProductTargetYield"
                filled
                type="number"
                :label="$gettext('Main product target yield')"
                :suffix="$gettext('t/ha')"
                :rules="[val => val > 0 || $gettext('This field must be positive')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />
            </template>

            <template v-if="hasCropByProductOptions">
              <q-select
                v-model="storeCropByProduct"
                :options="cropByProductOptions"
                option-value="id"
                option-label="name"
                filled
                :loading="loading"
                :label="$gettext('Crop by-product')"
                @update:model-value="onCropByProductChange"
                class="q-mt-md"
              />

              <q-input
                v-if="isCropByProductSelected"
                v-model.number="storeCropByProductTargetYield"
                filled
                type="number"
                :label="$gettext('By-product target yield')"
                :suffix="$gettext('t/ha')"
                :rules="[val => val > 0 || $gettext('This field must be positive')]"
                :min="0"
                step="0.1"
                hide-bottom-space
                :loading="loading"
                class="q-mt-md"
              />
            </template>
          </q-card-section>

          <q-card-section v-if="hasCropMainProductOptions">
            <q-select
              v-model="storePreFertilizationEffect"
              :options="preFertilizationEffectOptions"
              option-value="name"
              option-label="description"
              filled
              :loading="loading"
              :label="$gettext('Pre-fertilization effect')"
            />
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryPlantSpecies from 'src/pages/fieldbook/fertilization/algorithms/common/graphql/queryPlantSpecies'
import queryKalkulackyHnojenieCropProfile from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieCropProfile'
import queryKalkulackyHnojeniePreFertilizationEffectType from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojeniePreFertilizationEffectType'
import queryKalkulackyHnojenieCropProfilePlantSpecies from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieCropProfilePlantSpecies'
import { groupByKey } from 'src/utils/array'

const DEFAULT_PRE_FERTILIZATION_EFFECT_NAME = 'neutral'

export default {
  name: 'KalkulackyHnojenieCropProfilePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  data () {
    return {
      kalkulackyHnojenieCropProfiles: null,
      kalkulackyHnojeniePreFertilizationEffects: null,
      kalkulackyHnojenieCropMapping: null,
      plantSpecies: [],
      filterTermPlantSpecies: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Crop selection')
    },
    pageSubTitle () {
      return 'Kalkulacky Hnojenie'
    },
    canContinue () {
      return !this.loading && this.isParameterSet(this.storePreFertilizationEffect) &&
        this.isParameterSet(this.storeCropProfile) &&
        (!this.hasCropMainProductOptions || (this.isParameterSet(this.storeCropMainProduct) && this.isParameterSet(this.storeCropMainProductTargetYield))) &&
        (!this.hasCropByProductOptions || (this.isParameterSet(this.storeCropByProduct) && this.isParameterSet(this.storeCropByProductTargetYield)))
    },
    loading () {
      return (!this.plantSpecies && this.$apollo.queries.plantSpecies.loading) || !this.kalkulackyHnojenieCropProfiles || !this.kalkulackyHnojeniePreFertilizationEffects || !this.kalkulackyHnojenieCropMapping
    },
    preFertilizationEffectOptions () {
      return this.kalkulackyHnojeniePreFertilizationEffects || []
    },
    plotPlantSpecies () {
      return this.$store.state.fertilizationPlan.target.plot_plant_variety?.plant_variety?.plant_species
    },
    plotCropYield () {
      return this.$store.state.fertilizationPlan.target.plot_plant_variety?.crop_yield
    },
    matchingCropProfiles () {
      if (!this.kalkulackyHnojenieCropMapping) {
        return null
      } else {
        return this.kalkulackyHnojenieCropMapping
          .filter(row => row.plant_species_id === this.storePlantSpecies.id)
          .map(row => this.cropOptions.find(crop => crop.id === row.crop_profile.id))
      }
    },
    plantSpeciesOptions () {
      const options = this.plantSpecies
      if (this.filterTermPlantSpecies) {
        return options.filter(v => v.name?.toLowerCase().indexOf(this.filterTermPlantSpecies) > -1)
      } else {
        return options
      }
    },
    cropOptions () {
      if (!this.kalkulackyHnojenieCropProfiles) {
        return []
      } else {
        const options = []
        const activeCropProfiles = this.kalkulackyHnojenieCropProfiles
          .filter(profile => profile.is_active)
          .map(profile => ({
            id: profile.id,
            name: profile.name,
            byProductYieldDefaultRatio: profile.byproduct_yield_default_ratio,
            growingSeasonDefaultDuration: profile.growing_season_default_duration,
            cropProfileGroup: profile.crop_profile_group.name
          }))
        const cropProfilesByGroup = groupByKey(activeCropProfiles, 'cropProfileGroup')
        for (const group of Object.keys(cropProfilesByGroup).sort()) {
          options.push({ group })
          for (const profile of cropProfilesByGroup[group].sort((a, b) => a.name - b.name)) {
            options.push(profile)
          }
        }
        return options
      }
    },
    cropProfileOptions () {
      if (!this.kalkulackyHnojenieCropMapping || !this.storePlantSpecies?.id) {
        return []
      } else {
        return this.matchingCropProfiles
      }
    },
    cropProductOptions () {
      if (!this.kalkulackyHnojenieCropProfiles || !this.storeCropProfile?.id) {
        return []
      }
      const selectedCropProfile = this.kalkulackyHnojenieCropProfiles.find(profile => profile.id === this.storeCropProfile.id)
      return selectedCropProfile?.crop_profile_products || []
    },
    cropMainProductOptions () {
      return this.cropProductOptions.filter(product => product.product_type === 'main')
    },
    hasCropMainProductOptions () {
      return this.cropMainProductOptions.length > 0
    },
    cropByProductOptions () {
      return this.cropProductOptions.filter(product => product.product_type === 'by-product')
    },
    hasCropByProductOptions () {
      return this.cropByProductOptions.length > 0
    },
    preSelectedCropProfile () {
      if (!this.storeCropProfile) {
        // pre-select the first crop matching the plant species
        return this.matchingCropProfiles?.[0]
      }
      return null
    },
    preFilledCropTargetYield () {
      if (this.preSelectedCropProfile && !Number.isNaN(this.plotCropYield)) {
        return this.plotCropYield / 1000
      }
      return null
    },
    isCropMainProductSelected () {
      return this.hasCropMainProductOptions && this.isParameterSet(this.storeCropMainProduct)
    },
    isCropByProductSelected () {
      return this.hasCropByProductOptions && this.isParameterSet(this.storeCropByProduct)
    },
    showCropProfileUnavailableBanner () {
      return !this.loading && this.storePlantSpecies && !this.storeCropProfile && !this.preSelectedCropProfile
    },
    algorithmName () {
      return 'Kalkulacky Hnojenie'
    },
    storePreFertilizationEffect: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.preFertilizationEffect
      },
      set (v) {
        this.updateParameter('preFertilizationEffect', v)
      }
    },
    storePlantSpecies: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.plantSpecies
      },
      set (v) {
        this.updateParameter('plantSpecies', v)
      }
    },
    storeCropProfile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropProfile
      },
      set (v) {
        this.updateParameter('cropProfile', v)
      }
    },
    storeCropMainProduct: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropMainProduct
      },
      set (v) {
        this.updateParameter('cropMainProduct', v)
      }
    },
    storeCropMainProductTargetYield: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropMainProductTargetYield
      },
      set (v) {
        this.updateParameter('cropMainProductTargetYield', v)
      }
    },
    storeCropByProduct: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropByProduct
      },
      set (v) {
        this.updateParameter('cropByProduct', v)
      }
    },
    storeCropByProductTargetYield: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.cropByProductTargetYield
      },
      set (v) {
        this.updateParameter('cropByProductTargetYield', v)
      }
    }
  },
  apollo: {
    plantSpecies: {
      query: queryPlantSpecies,
      notifyOnNetworkStatusChange: true,
      update: data => data.plant_species
    }
  },
  async mounted () {
    if (!this.isParameterSet(this.storeCropProfile)) {
      this.storePlantSpecies = this.plotPlantSpecies
    }

    // Load data from cache (or online if not in cache)
    await this.loadData('cache-first')

    // Preselect crop profile if there is only one choice available
    if (!this.isParameterSet(this.storeCropProfile) && this.matchingCropProfiles.length === 1) {
      this.storeCropProfile = this.preSelectedCropProfile
    }

    // Refresh online data (do not wait until completion)
    this.loadData('network-only')
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'kalkulackyHnojenieSoil'
      })
    },
    onClickPrevious () {
      const isEdition = this.$store.state.fertilizationPlan.isEdition
      const isCreationFromPlot = this.$store.state.fertilizationPlan.isCreationFromPlot
      if (isEdition) {
        const fertilizationPlanId = this.$store.state.fertilizationPlan.fertilizationPlanIdAndName.id
        this.$router.replace({ name: 'fertilizationPlan', params: { fertilizationPlanId } })
      } else if (isCreationFromPlot) {
        const plotId = this.$store.state.fertilizationPlan.target.id
        this.$router.replace({ name: 'plot', params: { idPlot: plotId } })
      } else {
        this.$router.replace({ name: 'fertilizationPlanPlotSelection' })
      }
    },
    filterPlantSpecies (val, update) {
      update(() => {
        this.filterTermPlantSpecies = val.toLowerCase()
      })
    },
    onPlantSpeciesChange () {
      this.storeCropProfile = null
      if (this.matchingCropProfiles.length === 1) {
        this.storeCropProfile = this.preSelectedCropProfile
      }
      if (this.preFilledCropTargetYield && !this.isParameterSet(this.storeCropByProductTargetYield)) {
        this.storeCropByProductTargetYield = this.preFilledCropTargetYield
      }
      this.onCropProfileChange()
    },
    onUpdateCropProfileId (cropProfileId) {
      this.storeCropProfile = this.cropProfileOptions.find(crop => crop.id === cropProfileId)
      this.onCropProfileChange()
    },
    onCropProfileChange () {
      // reset fields depending on selected crop when it changes
      const preFilledCropMainProduct = this.cropMainProductOptions.length === 1 ? this.cropMainProductOptions[0] : null
      this.storeCropMainProduct = preFilledCropMainProduct
      const preFilledCropByProduct = this.cropByProductOptions.length === 1 ? this.cropByProductOptions[0] : null
      this.storeCropByProduct = preFilledCropByProduct
    },
    onCropMainProductChange () {
      const preFilledCropByProduct = this.cropByProductOptions.length === 1 ? this.cropByProductOptions[0] : null
      this.storeCropByProduct = preFilledCropByProduct
    },
    onCropByProductChange () {
      let defaultByProductTargetYield = 0
      if (this.storeCropProfile?.byProductYieldDefaultRatio && this.storeCropMainProductTargetYield) {
        defaultByProductTargetYield = Math.round(this.storeCropProfile?.byProductYieldDefaultRatio * this.storeCropMainProductTargetYield * 100) / 100
      }
      this.storeCropByProductTargetYield = defaultByProductTargetYield
    },
    async loadCropProfiles (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryKalkulackyHnojenieCropProfile,
        fetchPolicy
      })
      this.kalkulackyHnojenieCropProfiles = data?.kalkulacky_hnojenie__crop_profile
      if (this.preSelectedCropProfile) {
        this.updateParameter('cropProfile', this.preSelectedCropProfile)
        if (this.preFilledCropTargetYield) {
          this.updateParameter('cropMainProductTargetYield', this.preFilledCropTargetYield)
        }
        this.onCropProfileChange()
      }
    },
    async loadPreFertilizationEffects (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryKalkulackyHnojeniePreFertilizationEffectType,
        fetchPolicy
      })
      this.kalkulackyHnojeniePreFertilizationEffects = data?.__type.enumValues
      const defaultEffect = this.kalkulackyHnojeniePreFertilizationEffects.find(effect => effect.name === DEFAULT_PRE_FERTILIZATION_EFFECT_NAME)
      if (defaultEffect) {
        this.updateParameter('preFertilizationEffect', defaultEffect)
      }
    },
    async loadCropMapping (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryKalkulackyHnojenieCropProfilePlantSpecies,
        fetchPolicy
      })
      this.kalkulackyHnojenieCropMapping = data?.kalkulacky_hnojenie__crop_profile_plant_species
    },
    loadData (fetchPolicy) {
      return Promise.all([
        this.loadCropProfiles(fetchPolicy),
        this.loadPreFertilizationEffects(fetchPolicy),
        this.loadCropMapping(fetchPolicy)
      ])
    }
  }
}
</script>
